Update motioneye-install.sh

This commit is contained in:
tteckster 2022-04-18 07:33:08 -04:00 committed by GitHub
parent 5fa17902d8
commit 064d3d54bf
No known key found for this signature in database
GPG key ID: 4AEE18F83AFDEB23

View file

@ -1,38 +1,30 @@
#!/usr/bin/env bash #!/usr/bin/env bash -ex
set -euo pipefail
set -o errexit shopt -s inherit_errexit nullglob
set -o errtrace YW=`echo "\033[33m"`
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
trap 'die "Script interrupted."' INT
function error_exit() {
trap - ERR
local DEFAULT='Unknown failure occured.'
local REASON="\e[97m${1:-$DEFAULT}\e[39m"
local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
msg "$FLAG $REASON"
exit $EXIT
}
function msg() {
local TEXT="$1"
echo -e "$TEXT"
}
RD=`echo "\033[01;31m"` RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"` BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"` GN=`echo "\033[1;92m"`
CL=`echo "\033[m"` CL=`echo "\033[m"`
CM="${GN}${CL}"
CROSS="${RD}${CL}"
RETRY_NUM=10 RETRY_NUM=10
RETRY_EVERY=3 RETRY_EVERY=3
NUM=$RETRY_NUM NUM=$RETRY_NUM
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
echo -en "${GN} Setting up Container OS... " function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do while [ "$(hostname -I)" = "" ]; do
@ -45,16 +37,18 @@ while [ "$(hostname -I)" = "" ]; do
exit 1 exit 1
fi fi
done done
echo -e "${CM}${CL} \r" msg_ok "Set up Container OS"
echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} " msg_ok "Network Connected: ${BL}$(hostname -I)"
echo -e "${CM}${CL} \r"
echo -en "${GN} Installing Dependencies... " msg_info "Updating Container OS"
apt-get update &>/dev/null apt update &>/dev/null
apt-get -qqy install \ apt-get -qqy upgrade &>/dev/null
curl \ msg_ok "Updated Container OS"
sudo &>/dev/null
echo -e "${CM}${CL} \r" msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
msg_ok "Installed Dependencies"
echo -en "${GN} Installing Motion... " echo -en "${GN} Installing Motion... "
apt-get install motion -y &>/dev/null apt-get install motion -y &>/dev/null
@ -62,36 +56,36 @@ echo -en "${GN} Installing Motion... "
systemctl disable motion &>/dev/null systemctl disable motion &>/dev/null
echo -e "${CM}${CL} \r" echo -e "${CM}${CL} \r"
echo -en "${GN} Installing FFmpeg... " msg_info "Installing FFmpeg"
apt-get install ffmpeg v4l-utils -y &>/dev/null apt-get install ffmpeg v4l-utils -y &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed FFmpeg"
echo -en "${GN} Installing Python... " msg_info "Installing Python"
apt-get update &>/dev/null apt-get update &>/dev/null
apt-get install python2 -y &>/dev/null apt-get install python2 -y &>/dev/null
curl https://bootstrap.pypa.io/pip/2.7/get-pip.py --output get-pip.py &>/dev/null curl https://bootstrap.pypa.io/pip/2.7/get-pip.py --output get-pip.py &>/dev/null
python2 get-pip.py &>/dev/null python2 get-pip.py &>/dev/null
apt-get install libffi-dev libzbar-dev libzbar0 -y &>/dev/null apt-get install libffi-dev libzbar-dev libzbar0 -y &>/dev/null
apt-get install python2-dev libssl-dev libcurl4-openssl-dev libjpeg-dev -y &>/dev/null apt-get install python2-dev libssl-dev libcurl4-openssl-dev libjpeg-dev -y &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Python"
echo -en "${GN} Installing MotionEye... " msg_info "Installing MotionEye"
apt-get update &>/dev/null apt-get update &>/dev/null
sudo pip install motioneye &>/dev/null sudo pip install motioneye &>/dev/null
mkdir -p /etc/motioneye mkdir -p /etc/motioneye
cp /usr/local/share/motioneye/extra/motioneye.conf.sample /etc/motioneye/motioneye.conf cp /usr/local/share/motioneye/extra/motioneye.conf.sample /etc/motioneye/motioneye.conf
mkdir -p /var/lib/motioneye mkdir -p /var/lib/motioneye
echo -e "${CM}${CL} \r" msg_ok "Installed MotionEye"
echo -en "${GN} Creating Service file motioneye.service... " msg_info "Creating Service"
cp /usr/local/share/motioneye/extra/motioneye.systemd-unit-local /etc/systemd/system/motioneye.service &>/dev/null cp /usr/local/share/motioneye/extra/motioneye.systemd-unit-local /etc/systemd/system/motioneye.service &>/dev/null
systemctl enable motioneye &>/dev/null systemctl enable motioneye &>/dev/null
systemctl start motioneye systemctl start motioneye
echo -e "${CM}${CL} \r" msg_ok "Created Service"
PASS=$(grep -w "root" /etc/shadow | cut -b6); PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then if [[ $PASS != $ ]]; then
echo -en "${GN} Customizing Container... " msg_info "Customizing Container"
rm /etc/motd rm /etc/motd
rm /etc/update-motd.d/10-uname rm /etc/update-motd.d/10-uname
touch ~/.hushlogin touch ~/.hushlogin
@ -104,11 +98,11 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF EOF
systemctl daemon-reload systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//') systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
echo -e "${CM}${CL} \r" msg_ok "Customized Container"
fi fi
echo -en "${GN} Cleanup... " msg_info "Cleaning up"
apt-get autoremove >/dev/null apt-get autoremove >/dev/null
apt-get autoclean >/dev/null apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/* rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
echo -e "${CM}${CL} \n" msg_ok "Cleaned"